package hellocucumber;

import io.cucumber.datatable.DataTable;
import io.cucumber.java.en.Given;
import io.cucumber.java.en.Then;
import io.cucumber.java.en.When;
import org.junit.Assert;
import org.junit.Before;

import java.util.ArrayList;
import java.util.List;
import java.util.Map;

class BookStoreTest {
    static String bookStore(String bookStore){
        return null;
    }
}

public class BookStoreSteps {
    private BookStore store = new BookStore();
    private List<Book> foundBooks;

    @Before
    public void setUp(){
        foundBooks = new ArrayList<>();
    }

    @Given("^The following books are in the bookstore$")
    public void the_following_books_are_in_the_bookstore(DataTable data){
        List<Map<String, String>> rows = data.asMaps(String.class, String.class);

        for(Map<String, String> columns : rows) {
            store.addBook(new Book(columns.get("title"), columns.get("author")));
        }
    }

    @When("^I search for books by author Neal Stephenson$")
    public void i_search_for_books_by_author_neal_stephenson() throws Throwable {
        foundBooks = store.booksByAuthor("Neal Stephenson");
    }

    @Then("^I find (\\d+) books$")
    public void i_find_books(int arg1) throws Throwable {
        Assert.assertEquals(arg1, foundBooks.size());
    }

}
